<?php
/*
Plugin Name: Last.fm Recently Played Tracks
Plugin URI: http://ijustin.org/last-fm-widget
Description: Last.fm widget that supports customization for showing album art, how many tracks, and username. More customization to come soon! On load, uses jQuery (if JS enabled browser) to decrease page load time, but is still backwards compatible for non JS browsers. Shows track name, artist, and time played. Can also show user picture, tracks played, etc. No pesky "Support us" links.
Author: Justin Turner
Version: 1.1.3
Author URI: http://ijustin.org/
License: GPL2
*/
/*  Copyright 2010 Justin Turner (email : j.turner@ijustin.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    The license for this software can likely be found here: 
    http://www.gnu.org/licenses/gpl-2.0.html
*/
//this is the function that gathers the data from last.fm and styles it
function fetch_ijlastfm_data($username = 'just_in_time90',$trackNum = 3,$showArt = 1,$showUI = 1,$useReturn = 0){
if(false === ($latest = get_transient('ij_lastfm_widget_'.$username))){
$request_url = "http://ws.audioscrobbler.com/2.0/?method=user.getrecenttracks&user=".$username."&limit=50&api_key=f02d8c8d50cd86d57bed580b6c6aeda3";
$ch = curl_init();
$timeout = 5;
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
$latest = curl_exec($ch);
curl_close($ch);
set_transient('ij_lastfm_widget_'.$username, $latest, 120);
};
if(false === ($ui = get_transient('ij_lastfm_widget_uinfo_'.$username))){
$request_url = "http://ws.audioscrobbler.com/2.0/?method=user.getinfo&user=".$username."&api_key=f02d8c8d50cd86d57bed580b6c6aeda3";
$ch = curl_init();
$timeout = 5;
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
$ui = curl_exec($ch);
curl_close($ch);
set_transient('ij_lastfm_widget_uinfo_'.$username, $ui, 120);
};

$latest = new SimpleXMLElement($latest);
$ui = new SimpleXMLElement($ui);
if($latest->xpath('//track')){
//gather user info
$upic = $ui->user->image[1];
$username = $ui->user->name;
$playcount = $ui->user->playcount;
$timejoin = $ui->user->registered['unixtime'];
$fromCountry = $ui->user->country;

$theTracks = "";

if($showUI==1){
$theTracks = $theTracks."<div style='clear:both;padding-top:0px;padding-bottom:0px;'>";
if($upic!=''){
$theTracks = $theTracks."<img src='".$upic."' alt='Profile Pic for ".$username."' style='float:left;padding-right:5px;'/>";
};
$theTracks = $theTracks."<p style='font-weight:bold;padding:0px;margin:0px;'>".$username."</p>";
$theTracks = $theTracks."<p style='padding:0px;margin:0px;font-size:xx-small;'>".$playcount." plays since ".date("F j Y",(int)$timejoin)."</p>";
$theTracks = $theTracks."<p style='padding:0px;margin:0px;font-size:xx-small;'>Last.fm member for ".human_time_diff($timejoin)."</p>";
$theTracks = $theTracks."</div>";
};
$i=0;
foreach($latest->xpath('//track') as $track){
//get all the info
	$title = $track->xpath('//name');
	$title = $title[$i];
	$nowPlaying = $track->xpath('//track/@nowplaying');
	$datePlayed = $track->xpath('//date/@uts');
	$albumArt = $track->xpath('//image[@size="medium"]');
	$artist = $track->xpath('//artist');
//create the DIV
$theTracks = $theTracks."<div style='clear:both;padding-top:3px;padding-bottom:3px;'>";
	if($showArt==1){
//do we want to show album art?
	if($albumArt[$i] != ""){
	$theTracks = $theTracks."<img src='".$albumArt[$i]."'  width='52' height='52' alt='Album Art for ".$title."' style='float:left;padding-right:5px;'/>";
	}else{
	$theTracks = $theTracks."<img src='http://cdn.last.fm/flatness/catalogue/noimage/2/default_artist_medium.png' width='52' height='52' alt='No Album Art Available' style='float:left;padding-right:5px;'/>";
	};
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;margin-left:57px;'>".$title."</p>";
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;margin-left:57px;font-size:xx-small;'>".$artist[$i]."</p>";
	//lets see if this song is currently playing...
	if($nowPlaying[$i] != ""){
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;margin-left:57px;font-size:xx-small;'><img src='".WP_PLUGIN_URL."/lastfm-recently-played-tracks/images/icon_eq.gif' style='padding-right:3px;vertical-align:middle;'/>now playing!</p>";
	}else{
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;margin-left:57px;font-size:xx-small;'>about ".human_time_diff($datePlayed[$i])." ago</p>";
	};
	}else{
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;'>".$title."</p>";
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;font-size:xx-small;'>".$artist[$i]."</p>";
	//lets see if this song is currently playing...
	if($nowPlaying[$i] != ""){
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;font-size:xx-small;'>now playing!</p>";
	}else{
	$theTracks = $theTracks."<p style='padding:0px;margin:0px;font-size:xx-small;'>about ".human_time_diff($datePlayed[$i])." ago</p>";
	};
};
	$i++;
$theTracks = $theTracks."</div>";
	if($i == $trackNum){break;};
	if($i == 50){break;};
};
}else{
	$theTracks = "Something went wrong... Last.fm may be down.";
};
If($useReturn == 1){
return $theTracks;
}else{
echo $theTracks;
};
};
//this function is the actual widget that the end-user sees
function ij_lastfm_widget($args){
extract($args);
  $options = get_option("ij_lastfm_widget");
  if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Played',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1',
		'NoUseJS' => '0'
      );
  };
echo $before_widget;
echo $before_title.stripslashes($options['title']).$after_title;
if($options['NoUseJS']!=1){
?>
          <script type="text/javascript">
function CheckIt(checking)
{
var subSection = checking.substring(10,0).toLowerCase();
var answer = (subSection == "<div style");
if(answer){
jQuery("#ij_lastfm_widget").html(checking);
jQuery("#ij_lastfm_widget").show("slow");
}else{
jQuery("#ij_lastfm_widget").html("Something went wrong. We'll try again in a few minutes.");
jQuery("#ij_lastfm_widget").show("slow");
};
}
function fetchLastfm(){
            jQuery.ajax({ // load trough ajax to avoid waiting for lastfm's response
             type: "GET",url: "<?php bloginfo('url'); ?>",data: { username: '<?php echo $options['username']; ?>', trackNum: '<?php echo $options['trackNum']; ?>', showArt: '<?php echo $options['showArt']; ?>', showUI:'<?php echo $options['showUI']; ?>', get_ij_lastfm_data: 1 },
             beforeSend: function() {jQuery("#ij_loading_lastfm").show("slow");},
             complete: function() { jQuery("#ij_loading_lastfm").hide("fast");},
             success: function(html){
				CheckIt(html);
             }
            });
<?php
if($options['jsUpdate'] == 1){
echo 'setTimeout("fetchLastfm()",120000);';
};
?>
};
          // init
          jQuery(document).ready(function(){
			jQuery("#ij_loading_lastfm").html("Loading latest tracks...");
fetchLastfm();
          });
          </script>
<?php
}else{
?>
<div id="ij_lastfm_widget"><?php fetch_ijlastfm_data($options['username'], $options['trackNum'], $options['showArt'], $options['showUI']); ?></div>
<?php
};
?>
		<div id="ij_loading_lastfm"></div>
          <div id="ij_lastfm_widget"><noscript><?php fetch_ijlastfm_data($options['username'], $options['trackNum'], $options['showArt'], $options['showUI']); ?></noscript></div>
<?php
echo $after_widget;
};
//SHORTCODE
function ij_lastfm_shortcode($atts){
$options = get_option("ij_lastfm_widget");
if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Played',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1',
		'NoUseJS' => '0'
      );
};
extract(shortcode_atts(array(
		'username' => $options['username'],
		'tracks' => $options['trackNum'],
		'albumart' => $options['showArt'],
		'userinfo' => $options['showUI']
	), $atts));
	$result = "<p>";
	$result = $result.fetch_ijlastfm_data(wp_specialchars($username), wp_specialchars($tracks), wp_specialchars($albumart), wp_specialchars($userinfo), 1);
	$result = $result."</p>";
	return $result;
};
//this is the AJAX call function
function get_ij_lastfm_data(){
  if($_GET['get_ij_lastfm_data'] == 1){
    fetch_ijlastfm_data(wp_specialchars($_GET['username']), wp_specialchars($_GET['trackNum']), wp_specialchars($_GET['showArt']), wp_specialchars($_GET['showUI']));
    die();
  };
}
//add as an action so it can be called through AJAX
add_action('init', 'get_ij_lastfm_data');
//this is the control panel of the widget as seen on widget page
function ij_lastfm_widget_control()
{
  $options = get_option("ij_lastfm_widget");
  if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Played',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1',
		'NoUseJS' => '0'
      );
  };

if ($_POST['ij_lastfm_widget-Submit'])
	{
		$options['title'] = htmlspecialchars($_POST['ij_lastfm_widget-title']);
		$options['username'] = htmlspecialchars($_POST['ij_lastfm_widget-username']);
		$options['trackNum'] = htmlspecialchars($_POST['ij_lastfm_widget-trackNum']);
		$options['showArt'] = htmlspecialchars($_POST['ij_lastfm_widget-showArt']);
		$options['showUI'] = htmlspecialchars($_POST['ij_lastfm_widget-showUI']);
		$options['jsUpdate'] = htmlspecialchars($_POST['ij_lastfm_widget-jsUpdate']);
		$options['NoUseJS'] = htmlspecialchars($_POST['ij_lastfm_widget-NoUseJS']);
		update_option("ij_lastfm_widget", $options);
	}
 
?>
  <p>
    <label for="ij_lastfm_widget-title">Widget title:</label>
    <input type="text" id="ij_lastfm_widget-title" name="ij_lastfm_widget-title" value="<?php echo stripslashes($options['title']);?>" />
  </p>
  <p>
    <label for="ij_lastfm_widget-username">Last.fm username:</label>
    <input type="text" id="ij_lastfm_widget-username" name="ij_lastfm_widget-username" size="15" value="<?php echo stripslashes($options['username']);?>" />
  </p>
  <p>
    <label for="ij_lastfm_widget-trackNum">Number of tracks:</label>
<select id="ij_lastfm_widget-trackNum" name="ij_lastfm_widget-trackNum">
<?php
$x = 1;
do{
	echo "<option value=\"".$x."\"";
	if($options['trackNum']==$x){
		echo " selected=\"selected\"";
	};
	echo ">".$x."</option>";
	$x++;
}while($x > 0 && $x < 51);
?>
  </select>
  </p>
<p>
    <label for="ij_lastfm_widget-showArt">Show album art:</label>
<?php
if($options['showArt'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-showArt" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-showArt" value="1" />
<?php
};
?>
</p>
<p>
    <label for="ij_lastfm_widget-showUI">Show user info:</label>
<?php
if($options['showUI'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-showUI" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-showUI" value="1" />
<?php
};
?>
  </p>
<p>
    <label for="ij_lastfm_widget-NoUseJS">Don't use JavaScript to load:</label>
<?php
if($options['NoUseJS'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-NoUseJS" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-NoUseJS" value="1" />
<?php
};
?>
<BR><small>This disables JavaScript use completely. Only use if you seem to be having problems with tracks showing due to your theme, etc.</small>
  </p>
<?php
if($options['NoUseJS'] != 1){
?>
<p>
    <label for="ij_lastfm_widget-jsUpdate">Javscript update every 2 minutes:</label>
<?php
if($options['jsUpdate'] == 1){
?>
	<input type="checkbox" name="ij_lastfm_widget-jsUpdate" value="1" checked />
<?php
}else{
?>
	<input type="checkbox" name="ij_lastfm_widget-jsUpdate" value="1" />
<?php
};
?>
<BR><small>This is dependant upon if you use JavaScript or not. This option will disappear after you submit if you disable JavaScript.</small>
  </p>
<?php
};
?>
<input type="hidden" id="ij_lastfm_widget-Submit" name="ij_lastfm_widget-Submit" value="1" />
<?php
};
//this function registers the widget and control panel
function ij_lastfmWidget_init()
{
$options = get_option("ij_lastfm_widget");
if (!is_array($options))
{
$options = array(
		'title' => 'Last.fm Recently Played',
		'username' => 'just_in_time90',
		'trackNum' => '5',
		'showArt' => '1',
		'showUI' => '1',
		'jsUpdate' => '1',
		'NoUseJS' => '0'
      );
};
if($options['NoUseJS']!=1){
  wp_enqueue_script("jquery");
};
  register_sidebar_widget('Last.fm Widget','ij_lastfm_widget');
  register_widget_control('Last.fm Widget','ij_lastfm_widget_control',250,200);
};
//register widget
function ij_lastfmwidget_reg()
{
if(get_bloginfo() && curl_init()){
$blogname = get_bloginfo("name");
$blogurl = get_bloginfo("url");
$blogversion = get_bloginfo("version");
$pluginname= "Last.fm Plugin";
$request_url = "http://activation.ijustin.org/?blogname=".urlencode($blogname)."&blogurl=".urlencode($blogurl)."&blogversion=".urlencode($blogversion)."&plugin=".urlencode($pluginname)."&pluginversion=1.1.3";
$ch = curl_init();
$timeout = 5;
curl_setopt($ch, CURLOPT_URL, $request_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_USERAGENT, 'iJustin Activation System');
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
curl_exec($ch);
curl_close($ch);
};
};
//this function loads everything
register_activation_hook(__FILE__,'ij_lastfmwidget_reg');
add_action("plugins_loaded", "ij_lastfmWidget_init");
add_shortcode('lastfm', 'ij_lastfm_shortcode');
?>